#include "stdafx.h"

#include <jenga/include/smoothie/LexicalAnalysis.h>

#include "../BasicCompiler_Common/common.h"
#include "Opcode.h"

void FreeTempObject(int reg,const CClass *pobj_c){
	if(!IsSafeReg(reg)) SetError(300,NULL,cp);

	////////////////////////////////////////////////
	// ZߒŗpꎞIuWFNgj
	// This|C^r14WX^ēn
	////////////////////////////////////////////////

	const CMethod *method = pobj_c->GetDestructorMethod();
	if( method ){
		//mov rcx,reg
		op_mov_RR(REG_RCX,reg);

		//call DestructorProcAddr
		op_call( &method->GetUserProc() );
	}

	//mov rcx,reg
	op_mov_RR(REG_RCX,reg);

	//call free
	extern const UserProc *pSub_free;
	op_call(pSub_free);
}

int CallOperatorProc(BYTE idCalc, const Type &baseType, int *type_stack,LONG_PTR *index_stack,BOOL *bUseHeap,int &sp){
	//I[o[[hꂽIy[^֐Ăяo
	CClass *pobj_c;
	pobj_c=(CClass *)index_stack[sp-2];

	std::vector<const UserProc *> subs;
	pobj_c->GetMethods().Enum( idCalc, subs );
	if( subs.size() == 0 ){
		return 0;
	}


	//̐
	BOOL bTwoTerm=1;
	if(idCalc==CALC_AS) bTwoTerm=0;


	/////////////////////////////////////////////
	// I[o[[hp̃p[^ݒ
	/////////////////////////////////////////////

	Parameters params;

	if(bTwoTerm){
		params.push_back( new Parameter( "", Type( type_stack[sp-1], index_stack[sp-1] ) ) );
	}

	//I[o[[h
	char temporary[255];
	if(idCalc==CALC_EQUAL) lstrcpy(temporary,"==");
	else GetCalcName(idCalc,temporary);
	const UserProc *pUserProc = OverloadSolution( temporary, subs, params, baseType );

	if(!pUserProc){
		if(bTwoTerm){
			delete params[0];
		}
		return -1;
	}
	else{
		//I[o[[hĂȂAp[^vȂƂ
		if(params.size()!=pUserProc->Params().size()){
			if(bTwoTerm){
				delete params[0];
			}
			return -1;
		}
	}

	for(int i=0;i<(int)params.size();i++){
		CheckDifferentType(
			pUserProc->Params()[i]->GetBasicType(),
			pUserProc->Params()[i]->GetIndex(),
			params[i]->GetBasicType(),
			params[i]->GetIndex(),
			"",
			i);
	}

	if(bTwoTerm){
		delete params[0];
	}

	int right_side_size = GetTypeSize(type_stack[sp-1],index_stack[sp-1]);

	if(bTwoTerm){
		if( pUserProc->RealParams()[1]->IsStruct() &&pUserProc->RealParams()[1]->IsRef() == false ){
			//ꎞIuWFNg̓\bhŔj
			bUseHeap[sp-1]=0;
		}
	}


	if( pUserProc->ReturnType().IsStruct() ){
		//////////////////////////////////////////////////////
		// ߂lɍ\̃CX^Xꍇ
		// ByRef _System_ReturnValue p[^p̈擾
		//////////////////////////////////////////////////////


		//////////////////////////////////////////////////////
		/////    WX^̃obNAbv
		{	BACKUP_REGISTER_RESOURCE
		//////////////////////////////////////////////////////

			int object_size = pUserProc->ReturnType().GetClass().GetSize();

			//mov rcx,object_size
			op_mov_RV(sizeof(_int64),REG_RCX,object_size);

			//call calloc
			extern const UserProc *pSub_calloc;
			op_call(pSub_calloc);

			//mov r13,rax
			op_mov_RR(REG_R13,REG_RAX);

		/////////////////////////////////////////////
		//////   WX^𕜌
			RESTORE_REGISTER_RESOURCE
		}////////////////////////////////////////////
	}

	int reg1,reg2;
	if(bTwoTerm){
		//E̍ȉꍇj
		SetOneTermToReg_Whole64Calc(type_stack[sp-1],&reg2);
		pobj_reg->UnlockReg();
		if( !pUserProc->RealParams()[1]->IsRef() == false ){
			//ꎞQƂ쐬
			pobj_sf->push( reg2 );
			pobj_sf->mov_sp( reg2 );
		}
	}

	//̍
	SetOneTermToReg_Whole64Calc(DEF_INT64,&reg1);
	pobj_reg->UnlockReg();

	//q[vpɑޔ
	if(bUseHeap[sp-1]){
		//mov qword ptr[rsp+offset],reg2     X^bNt[𗘗p
		pobj_sf->push(reg2);
	}
	if(bUseHeap[sp-2]){
		//mov qword ptr[rsp+offset],reg1     X^bNt[𗘗p
		pobj_sf->push(reg1);
	}



	//////////////////////////////////////////////////////
	/////    WX^̃obNAbv
	{	BACKUP_REGISTER_RESOURCE
	//////////////////////////////////////////////////////

		if(reg1==REG_RDX||reg1==REG_R8){
			//mov r14,reg1
			op_mov_RR(REG_R14,reg1);
			reg1=REG_R14;
		}


		if(bTwoTerm){
			if( pUserProc->ReturnType().IsStruct() ){
				//mov r8,reg2
				op_mov_RR(REG_R8,reg2);
			}
			else{
				//mov rdx,reg2
				op_mov_RR(REG_RDX,reg2);
			}
		}

		if( pUserProc->ReturnType().IsStruct() ){
			//mov rdx,r13
			op_mov_RR(REG_RDX,REG_R13);
		}

		//mov rcx,reg1
		op_mov_RR(REG_RCX,reg1);

		//call operator_proc
		op_call(pUserProc);

		if( !pUserProc->ReturnType().IsNull() ){
			//߂lꎞIɑޔ

			//mov r13,rax
			op_mov_RR(REG_R13,REG_RAX);
		}


	/////////////////////////////////////////////
	//////   WX^𕜌
		RESTORE_REGISTER_RESOURCE
	}////////////////////////////////////////////



	if(bUseHeap[sp-2]||bUseHeap[sp-1]){

		//////////////////////////////////////////////////////
		/////    WX^̃obNAbv
		{	BACKUP_REGISTER_RESOURCE
		//////////////////////////////////////////////////////

			if(bUseHeap[sp-2]){
				//mov r14,qword ptr[rsp+offset]     X^bNt[𗘗p
				pobj_sf->pop(REG_R14);

				FreeTempObject(REG_R14,(CClass *)index_stack[sp-2]);
			}
			if(bUseHeap[sp-1]){
				//mov r14,qword ptr[rsp+offset]     X^bNt[𗘗p
				pobj_sf->pop(REG_R14);

				FreeTempObject(REG_R14,(CClass *)index_stack[sp-1]);
			}

		/////////////////////////////////////////////
		//////   WX^𕜌
			RESTORE_REGISTER_RESOURCE
		}////////////////////////////////////////////
	}

	if(bTwoTerm){
		if( !pUserProc->RealParams()[1]->IsRef() == false ){
			//ꎞQƂj
			pobj_sf->pop();
		}
	}

	if( !pUserProc->ReturnType().IsNull() ){
		//߂lreg1ɃZbg
		reg1=pobj_reg->LockReg();

		//mov reg1,r13
		op_mov_RR(reg1,REG_R13);
	}

	sp--;
	type_stack[sp-1]=pUserProc->ReturnType().GetBasicType();
	index_stack[sp-1]=pUserProc->ReturnType().GetIndex();

	if( pUserProc->ReturnType().IsStruct() ){
		//\̂߂Ƃ̓q[v̈ɃCX^Xi[Ă
		//freeKv
		bUseHeap[sp-1]=1;
	}
	else bUseHeap[sp-1]=0;

	return 1;
}

void CallCastOperatorProc(int reg,Type &calcType,BOOL bCalcUseHeap,const Type &toType){
	int type_stack[10];
	LONG_PTR index_stack[10];
	BOOL array_bUseHeap[10];
	int sp=2;
	int iRet;


	//////////////////////////////////////////////////////
	/////    WX^̃obNAbv
	{	BACKUP_REGISTER_RESOURCE
	//////////////////////////////////////////////////////

		//regꍀڂƂăbN
		pobj_reg=new CRegister(reg);
		pobj_reg->LockReg();

		if(bCalcUseHeap){
			//̃CX^X݂|x
			SetError(-105,NULL,cp);
		}

		//
		type_stack[0]=calcType.GetBasicType();
		index_stack[0]=calcType.GetIndex();
		array_bUseHeap[0]=0;
		type_stack[1]=toType.GetBasicType();
		index_stack[1]=toType.GetIndex();
		array_bUseHeap[1]=0;

		iRet=CallOperatorProc(CALC_AS,toType,type_stack,index_stack,array_bUseHeap,sp);

		pobj_reg->UnlockReg();

	/////////////////////////////////////////////
	//////   WX^𕜌
		RESTORE_REGISTER_RESOURCE
	}////////////////////////////////////////////


	if(iRet==1){
		//Ƃ
		calcType.SetType( type_stack[0], index_stack[0] );
		return;
	}
	else if(iRet==-1){
		//G[sꂽƂ
		return;
	}

	//G[𔭍s
	SetError(-1,"LXgZqI[o[[hĂ܂B",cp);
}

//CfNTigetterjĂяo
void CallIndexerGetterProc(int reg,const CClass *pobj_Class,char *ObjectName,char *Parameter,Type &resultType ){

	std::vector<const UserProc *> subs;
	pobj_Class->GetMethods().Enum( CALC_ARRAY_GET, subs );
	if( subs.size() == 0 ){
		return;
	}

	//////////////////////////////////////////////////////
	/////    WX^̃obNAbv
	{	BACKUP_REGISTER_RESOURCE
	//////////////////////////////////////////////////////

		Opcode_CallProc(Parameter,subs[0],0,ObjectName,DEF_OBJECT);
		resultType = subs[0]->ReturnType();

		//mov reg,rax
		op_mov_RR(reg,REG_RAX);

	/////////////////////////////////////////////
	//////   WX^𕜌
		RESTORE_REGISTER_RESOURCE
	}////////////////////////////////////////////

}
